const helpers = require("./helpers")
const ms = require("ms")
const R = require("rambda")

const everyMethod = (inputCollection, behaviourCollection) => {
  const methodArgument = R.compose(
    R.ifElse(
      x => x.length > 0,
      R.head,
      () => false
    ),
    R.filter(
      R.startsWith("EVERY")
    )
  )(behaviourCollection)

  if (methodArgument === false) {
    return
  }
  const fn = R.ifElse(
    x => R.type(R.head(x)) === "Function",
    R.head,
    R.F
  )(inputCollection)
  if (fn === false) {
    return "EXIT"
  }

  const tagRequestValue = helpers.getTag(behaviourCollection)

  const tag = R.ifElse(
    x => x === false,
    () => helpers.intervals.GENERIC_INTERVAL === undefined ? "GENERIC_INTERVAL" : false,
    R.identity
  )(tagRequestValue)

  if (tag === false) {
    return "EXIT"
  }

  const msInput = R.replace("EVERY", "")(methodArgument)
  helpers.intervals[ tag ] = setInterval(() => {
    console.log(fn())
  }, ms(msInput))
  //console.log(tag,'tag')
  //console.log(msInput,methodArgument,'msInput')
  return "EXIT"
}

module.exports = everyMethod
